Index: pjproject/trunk/pjsip/src/pjsip-simple/evsub_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-simple/evsub_msg.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip-simple/evsub_msg.c	(revision 1417)
@@ -62,4 +62,5 @@
     char *endbuf = buf+size;
     int printed;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     copy_advance(p, hdr->name);
@@ -71,6 +72,6 @@
     
     printed = pjsip_param_print_on(&hdr->other_param, p, endbuf-p,
-				   &pjsip_TOKEN_SPEC, 
-				   &pjsip_TOKEN_SPEC, ';');
+				   &pc->pjsip_TOKEN_SPEC, 
+				   &pc->pjsip_TOKEN_SPEC, ';');
     if (printed < 0)
 	return printed;
@@ -160,4 +161,5 @@
     char *endbuf = buf+size;
     int printed;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     copy_advance(p, hdr->name);
@@ -181,6 +183,6 @@
     
     printed = pjsip_param_print_on( &hdr->other_param, p, endbuf-p, 
-				    &pjsip_TOKEN_SPEC,
-				    &pjsip_TOKEN_SPEC,
+				    &pc->pjsip_TOKEN_SPEC,
+				    &pc->pjsip_TOKEN_SPEC,
 				    ';');
     if (printed < 0)
@@ -223,6 +225,7 @@
     pjsip_event_hdr *hdr = pjsip_event_hdr_create(ctx->pool);
     const pj_str_t id_param = { "id", 2 };
-
-    pj_scan_get(ctx->scanner, &pjsip_TOKEN_SPEC, &hdr->event_type);
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
+
+    pj_scan_get(ctx->scanner, &pc->pjsip_TOKEN_SPEC, &hdr->event_type);
 
     while (*ctx->scanner->curptr == ';') {
@@ -254,5 +257,7 @@
 		   expires = { "expires", 7 },
 		   retry_after = { "retry-after", 11 };
-    pj_scan_get(ctx->scanner, &pjsip_TOKEN_SPEC, &hdr->sub_state);
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
+
+    pj_scan_get(ctx->scanner, &pc->pjsip_TOKEN_SPEC, &hdr->sub_state);
 
     while (*ctx->scanner->curptr == ';') {
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 1417)
@@ -114,7 +114,4 @@
 };
 
-/* Config */
-extern pj_bool_t pjsip_include_allow_hdr_in_dlg;
-
 /*
  * Module load()
@@ -224,5 +221,5 @@
 	      pjsip_rx_data_get_info(rdata)));
 
-    status = pjsip_dlg_create_request(inv->dlg, &pjsip_ack_method, 
+    status = pjsip_dlg_create_request(inv->dlg, pjsip_get_ack_method(), 
 				      rdata->msg_info.cseq->cseq, &tdata);
     if (status != PJ_SUCCESS) {
@@ -1109,5 +1106,5 @@
 
     /* Create the INVITE request. */
-    status = pjsip_dlg_create_request(inv->dlg, &pjsip_invite_method, -1,
+    status = pjsip_dlg_create_request(inv->dlg, pjsip_get_invite_method(), -1,
 				      &tdata);
     if (status != PJ_SUCCESS)
@@ -1156,5 +1153,5 @@
 
     /* Add Allow header. */
-    if (pjsip_include_allow_hdr_in_dlg) {
+    if (inv->dlg->add_allow) {
 	hdr = pjsip_endpt_get_capability(inv->dlg->endpt, PJSIP_H_ALLOW, NULL);
 	if (hdr) {
@@ -1598,6 +1595,6 @@
     case PJSIP_INV_STATE_CONFIRMED:
 	/* For established dialog, send BYE */
-	status = pjsip_dlg_create_request(inv->dlg, &pjsip_bye_method, -1, 
-					  &tdata);
+	status = pjsip_dlg_create_request(inv->dlg, pjsip_get_bye_method(), 
+					  -1, &tdata);
 	break;
 
@@ -1793,5 +1790,5 @@
 
     pjsip_tsx_create_key(rdata->tp_info.pool, &key, PJSIP_ROLE_UAS,
-			 &pjsip_invite_method, rdata);
+			 pjsip_get_invite_method(), rdata);
     invite_tsx = pjsip_tsx_layer_find_tsx(&key, PJ_TRUE);
 
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 1417)
@@ -367,5 +367,5 @@
     /* Create the request. */
     status = pjsip_endpt_create_request_from_hdr( regc->endpt, 
-						  &pjsip_register_method,
+						  pjsip_get_register_method(),
 						  regc->srv_url,
 						  regc->from_hdr,
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 1417)
@@ -69,4 +69,5 @@
     char *endbuf = buf+size;
     int printed;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     copy_advance(p, hdr->name);
@@ -84,6 +85,6 @@
     
     printed = pjsip_param_print_on(&hdr->other_param, p, endbuf-p,
-				   &pjsip_TOKEN_SPEC, 
-				   &pjsip_TOKEN_SPEC, ';');
+				   &pc->pjsip_TOKEN_SPEC, 
+				   &pc->pjsip_TOKEN_SPEC, ';');
     if (printed < 0)
 	return printed;
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 1417)
@@ -58,9 +58,13 @@
 };
 
-const pjsip_method pjsip_refer_method = {
+PJ_DEF_DATA(const pjsip_method) pjsip_refer_method = {
     (pjsip_method_e) PJSIP_REFER_METHOD,
     { "REFER", 5}
 };
 
+PJ_DEF(const pjsip_method*) pjsip_get_refer_method()
+{
+    return &pjsip_refer_method;
+}
 
 /*
@@ -145,5 +149,6 @@
 
     status = pjsip_endpt_add_capability( endpt, &mod_xfer, PJSIP_H_ALLOW, 
-					 NULL, 1, &pjsip_refer_method.name);
+					 NULL, 1, 
+					 &pjsip_get_refer_method()->name);
     if (status != PJ_SUCCESS)
 	return status;
@@ -224,5 +229,5 @@
     /* Check that request is REFER */
     PJ_ASSERT_RETURN(pjsip_method_cmp(&rdata->msg_info.msg->line.req.method,
-				      &pjsip_refer_method)==0,
+				      pjsip_get_refer_method())==0,
 		     PJSIP_ENOTREFER);
 
@@ -299,5 +304,5 @@
 
     /* Create basic REFER request */
-    status = pjsip_evsub_initiate(sub, &pjsip_refer_method, -1, 
+    status = pjsip_evsub_initiate(sub, pjsip_get_refer_method(), -1, 
 				  &tdata);
     if (status != PJ_SUCCESS)
Index: pjproject/trunk/pjsip/src/pjsip/sip_auth_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_auth_msg.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip/sip_auth_msg.c	(revision 1417)
@@ -68,4 +68,5 @@
     char *startbuf = buf;
     char *endbuf = buf + size;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
     
     copy_advance_pair_quote_cond(buf, "username=", 9, cred->username, '"', '"');
@@ -84,6 +85,6 @@
     
     printed = pjsip_param_print_on(&cred->other_param, buf, endbuf-buf, 
-				   &pjsip_TOKEN_SPEC, 
-				   &pjsip_TOKEN_SPEC, ',');
+				   &pc->pjsip_TOKEN_SPEC, 
+				   &pc->pjsip_TOKEN_SPEC, ',');
     if (printed < 0)
 	return -1;
@@ -229,4 +230,5 @@
     char *startbuf = buf;
     char *endbuf = buf + size;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     copy_advance_pair_quote_cond(buf, " realm=", 7, chal->realm, '"', '"');
@@ -242,6 +244,6 @@
     
     printed = pjsip_param_print_on(&chal->other_param, buf, endbuf-buf, 
-				   &pjsip_TOKEN_SPEC, 
-				   &pjsip_TOKEN_SPEC, ',');
+				   &pc->pjsip_TOKEN_SPEC, 
+				   &pc->pjsip_TOKEN_SPEC, ',');
     if (printed < 0)
 	return -1;
Index: pjproject/trunk/pjsip/src/pjsip/sip_auth_parser.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_auth_parser.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip/sip_auth_parser.c	(revision 1417)
@@ -196,4 +196,6 @@
 					 pjsip_authorization_hdr *hdr)
 {
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
+    
     if (*scanner->curptr == '"') {
 	pj_scan_get_quote(scanner, '"', '"', &hdr->scheme);
@@ -201,5 +203,5 @@
 	hdr->scheme.slen -= 2;
     } else {
-	pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->scheme);
+	pj_scan_get(scanner, &pc->pjsip_TOKEN_SPEC, &hdr->scheme);
     }
 
@@ -222,4 +224,6 @@
 					pjsip_www_authenticate_hdr *hdr)
 {
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
+
     if (*scanner->curptr == '"') {
 	pj_scan_get_quote(scanner, '"', '"', &hdr->scheme);
@@ -227,5 +231,5 @@
 	hdr->scheme.slen -= 2;
     } else {
-	pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->scheme);
+	pj_scan_get(scanner, &pc->pjsip_TOKEN_SPEC, &hdr->scheme);
     }
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_dialog.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 1417)
@@ -82,4 +82,5 @@
     dlg->endpt = endpt;
     dlg->state = PJSIP_DIALOG_STATE_NULL;
+    dlg->add_allow = pjsip_include_allow_hdr_in_dlg;
 
     pj_list_init(&dlg->inv_hdr);
@@ -1201,5 +1202,5 @@
 
 	/* Add Allow header in 2xx and 405 response. */
-	if (((st_class==2 && pjsip_include_allow_hdr_in_dlg)
+	if (((st_class==2 && dlg->add_allow)
 	     || st_code==405) &&
 	    pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ALLOW, NULL)==NULL) 
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 1417)
@@ -35,5 +35,5 @@
 #include <pj/lock.h>
 
-#define PJSIP_EX_NO_MEMORY  PJ_NO_MEMORY_EXCEPTION
+#define PJSIP_EX_NO_MEMORY  pj_NO_MEMORY_EXCEPTION()
 #define THIS_FILE	    "sip_endpoint.c"
 
@@ -117,22 +117,4 @@
 /* Specifies whether error subsystem has been registered to pjlib. */
 static int error_subsys_initialized;
-
-/**
- * Defined in sip_errno.c
- *
- * Get error message for the specified error code. This can only get
- * PJSIP specific error message. To get all types of error message,
- * use pj_strerror() instead.
- *
- * @param status    The error code.
- * @param buffer    The buffer where to put the error message.
- * @param bufsize   Size of the buffer.
- *
- * @return	    The error message as NULL terminated string,
- *                  wrapped with pj_str_t.
- */
-PJ_DECL(pj_str_t) pjsip_strerror( pj_status_t status, char *buffer,
-				  pj_size_t bufsize);
-
 
 /*
Index: pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 1416)
+++ pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 1417)
@@ -25,11 +25,59 @@
 #include <pj/assert.h>
 
-const pjsip_method 
-    pjsip_invite_method	    = { PJSIP_INVITE_METHOD,	{ "INVITE",6 }	},
-    pjsip_cancel_method	    = { PJSIP_CANCEL_METHOD,	{ "CANCEL",6 }	},
-    pjsip_ack_method	    = { PJSIP_ACK_METHOD,	{ "ACK",3}	},
-    pjsip_bye_method	    = { PJSIP_BYE_METHOD,	{ "BYE",3}	},
-    pjsip_register_method   = { PJSIP_REGISTER_METHOD,	{ "REGISTER",8}	},
-    pjsip_options_method    = { PJSIP_OPTIONS_METHOD,	{ "OPTIONS",7}	};
+PJ_DEF_DATA(const pjsip_method) pjsip_invite_method =
+	{ PJSIP_INVITE_METHOD, { "INVITE",6 }};
+
+PJ_DEF_DATA(const pjsip_method) pjsip_cancel_method =
+	{ PJSIP_CANCEL_METHOD, { "CANCEL",6 }};
+
+PJ_DEF_DATA(const pjsip_method) pjsip_ack_method =
+	{ PJSIP_ACK_METHOD, { "ACK",3}};
+
+PJ_DEF_DATA(const pjsip_method) pjsip_bye_method =
+	{ PJSIP_BYE_METHOD, { "BYE",3}};
+
+PJ_DEF_DATA(const pjsip_method) pjsip_register_method =
+	{ PJSIP_REGISTER_METHOD, { "REGISTER", 8}};
+
+PJ_DEF_DATA(const pjsip_method) pjsip_options_method =
+	{ PJSIP_OPTIONS_METHOD, { "OPTIONS",7}};
+
+
+/** INVITE method constant. */
+PJ_DEF(const pjsip_method*) pjsip_get_invite_method(void)
+{
+    return &pjsip_invite_method;
+}
+
+/** CANCEL method constant. */
+PJ_DEF(const pjsip_method*) pjsip_get_cancel_method(void)
+{
+    return &pjsip_cancel_method;
+}
+
+/** ACK method constant. */
+PJ_DEF(const pjsip_method*) pjsip_get_ack_method(void)
+{
+    return &pjsip_ack_method;
+}
+
+/** BYE method constant. */
+PJ_DEF(const pjsip_method*) pjsip_get_bye_method(void)
+{
+    return &pjsip_bye_method;
+}
+
+/** REGISTER method constant.*/
+PJ_DEF(const pjsip_method*) pjsip_get_register_method(void)
+{
+    return &pjsip_register_method;
+}
+
+/** OPTIONS method constant. */
+PJ_DEF(const pjsip_method*) pjsip_get_options_method(void)
+{
+    return &pjsip_options_method;
+}
+
 
 static const pj_str_t *method_names[] = 
@@ -566,9 +614,8 @@
 
 
-PJ_DEF(pjsip_generic_string_hdr*) 
-pjsip_generic_string_hdr_init( pj_pool_t *pool,
-			       void *mem,
-			       const pj_str_t *hnames,
-			       const pj_str_t *hvalue)
+PJ_DEF(pjsip_generic_string_hdr*) pjsip_generic_string_hdr_init(pj_pool_t *pool,
+					       void *mem,
+					       const pj_str_t *hnames,
+					       const pj_str_t *hvalue)
 {
     pjsip_generic_string_hdr *hdr = (pjsip_generic_string_hdr*) mem;
@@ -591,6 +638,5 @@
 }
 
-PJ_DEF(pjsip_generic_string_hdr*) 
-pjsip_generic_string_hdr_create( pj_pool_t *pool,
+PJ_DEF(pjsip_generic_string_hdr*) pjsip_generic_string_hdr_create(pj_pool_t *pool,
 				 const pj_str_t *hnames,
 				 const pj_str_t *hvalue)
@@ -1056,4 +1102,5 @@
 {
     const pj_str_t *hname = pjsip_use_compact_form? &hdr->sname : &hdr->name;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     if (hdr->star) {
@@ -1110,5 +1157,6 @@
 
 	printed = pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf,
-				       &pjsip_TOKEN_SPEC, &pjsip_TOKEN_SPEC, 
+				       &pc->pjsip_TOKEN_SPEC,
+				       &pc->pjsip_TOKEN_SPEC, 
 				       ';');
 	if (printed < 0)
@@ -1347,4 +1395,5 @@
     char *endbuf = buf + size;
     const pj_str_t *hname = pjsip_use_compact_form? &hdr->sname : &hdr->name;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     copy_advance(buf, (*hname));
@@ -1362,6 +1411,6 @@
 
     printed = pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf, 
-				   &pjsip_TOKEN_SPEC,
-				   &pjsip_TOKEN_SPEC, ';');
+				   &pc->pjsip_TOKEN_SPEC,
+				   &pc->pjsip_TOKEN_SPEC, ';');
     if (printed < 0)
 	return -1;
@@ -1525,4 +1574,5 @@
     char *startbuf = buf;
     char *endbuf = buf + size;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
     /* Route and Record-Route don't compact forms */
 
@@ -1538,6 +1588,6 @@
 
     printed = pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf, 
-				   &pjsip_TOKEN_SPEC, 
-				   &pjsip_TOKEN_SPEC, ';');
+				   &pc->pjsip_TOKEN_SPEC, 
+				   &pc->pjsip_TOKEN_SPEC, ';');
     if (printed < 0)
 	return -1;
@@ -1705,4 +1755,5 @@
     pj_str_t sip_ver = { "SIP/2.0/", 8 };
     const pj_str_t *hname = pjsip_use_compact_form? &hdr->sname : &hdr->name;
+    const pjsip_parser_const_t *pc = pjsip_parser_const();
 
     if ((pj_ssize_t)size < hname->slen + sip_ver.slen + 
@@ -1758,6 +1809,6 @@
     
     printed = pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf, 
-				   &pjsip_TOKEN_SPEC,
-				   &pjsip_TOKEN_SPEC, ';');
+				   &pc->pjsip_TOKEN_SPEC,
+				   &pc->pjsip_TOKEN_SPEC, ';');
     if (printed < 0)
 	return -1;
@@ -1814,8 +1865,7 @@
 }
 
-PJ_DEF(pjsip_warning_hdr*) 
-pjsip_warning_hdr_create_from_status( pj_pool_t *pool,
-				      const pj_str_t *host,
-				      pj_status_t status)
+PJ_DEF(pjsip_warning_hdr*) pjsip_warning_hdr_create_from_status(pj_pool_t *pool,
+						      const pj_str_t *host,
+						      pj_status_t status)
 {
     char errbuf[PJ_ERR_MSG_SIZE];
